Package org.eclipse.ui.navigator

# Interface INavigatorViewerDescriptor

public interface INavigatorViewerDescriptor
Provides a basic metadata about the abstract viewer for a particular content service.

Since:
  3.2
Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final String`
`PROP_CUSTOMIZE_VIEW_DIALOG_HELP_CONTEXT`
"org.eclipse.ui.navigator.customizeViewDialogHelpContext" (string): The help context id to be used for the "Filters and Customization" view dialog, if not specified help will not be available.
`static final String`
`PROP_ENABLE_TOOLTIP_SUPPORT`
"org.eclipse.ui.navigator.enableTooltipSupport" (boolean): True indicates that tooltip support shall be installed for the viewer.
`static final String`
`PROP_HIDE_AVAILABLE_CUSTOMIZATIONS_DIALOG`
"org.eclipse.ui.navigator.hideAvailableCustomizationsDialog" (boolean): True indicates the entire "Filters and Customization" dialog should not be available for the user (defaults to false).
`static final String`
`PROP_HIDE_AVAILABLE_EXT_TAB`
"org.eclipse.ui.navigator.hideAvailableExtensionsTab" (boolean): True indicates the "Available Extensions" tab in the "Filters and Customization" dialog should not be available for the user (defaults to false).
`static final String`
`PROP_HIDE_COLLAPSE_ALL_ACTION`
"org.eclipse.ui.navigator.hideCollapseAllAction" (boolean): True indicates the "Collapse All" button should not be available for the user (defaults to false).
`static final String`
`PROP_HIDE_LINK_WITH_EDITOR_ACTION`
"org.eclipse.ui.navigator.hideLinkWithEditorAction" (boolean): True indicates the "Link With Editor" action should not be available for the user (defaults to false).

## Method Summary

Modifier and Type
Method
Description
`boolean`
`allowsPlatformContributionsToContextMenu()`
Returns true by default.
`boolean`
`getBooleanConfigProperty(String aPropertyName)`
`MenuInsertionPoint[]`
`getCustomInsertionPoints()`
Custom insertion points are declared through a nested 'popupMenu' element in the org.eclipse.ui.navigator.viewer extension point.
`String`
`getHelpContext()`
`String`
`getPopupMenuId()`
The default value of the popup menu id is the viewer id.
`String`
`getStringConfigProperty(String aPropertyName)`
`String`
`getViewerId()`
Returns the id of the viewer targeted by this extension.
`boolean`
`hasOverriddenRootExtensions()`
Returns true if there exists at least one matching viewerContentBinding which declares isRoot as true.
`boolean`
`isRootExtension(String aContentExtensionId)`
Returns true if the content extension of the given id matches a viewerContentBinding extension that declares isRoot as true.
`boolean`
`isVisibleActionExtension(String anActionExtensionId)`
Returns true if the action extension of the given id is 'visible'.
`boolean`
`isVisibleContentExtension(String aContentExtensionId)`
Returns true if the content extension of the given id is 'visible'.

## Field Details

### PROP_HIDE_AVAILABLE_EXT_TAB

static final String PROP_HIDE_AVAILABLE_EXT_TAB
"org.eclipse.ui.navigator.hideAvailableExtensionsTab" (boolean): True indicates the "Available Extensions" tab in the "Filters and Customization" dialog should not be available for the user (defaults to false).

See Also:
  - Constant Field Values

### PROP_HIDE_AVAILABLE_CUSTOMIZATIONS_DIALOG

static final String PROP_HIDE_AVAILABLE_CUSTOMIZATIONS_DIALOG
"org.eclipse.ui.navigator.hideAvailableCustomizationsDialog" (boolean): True indicates the entire "Filters and Customization" dialog should not be available for the user (defaults to false).

See Also:
  - Constant Field Values

### PROP_HIDE_COLLAPSE_ALL_ACTION

static final String PROP_HIDE_COLLAPSE_ALL_ACTION
"org.eclipse.ui.navigator.hideCollapseAllAction" (boolean): True indicates the "Collapse All" button should not be available for the user (defaults to false).

See Also:
  - Constant Field Values

### PROP_HIDE_LINK_WITH_EDITOR_ACTION

static final String PROP_HIDE_LINK_WITH_EDITOR_ACTION
"org.eclipse.ui.navigator.hideLinkWithEditorAction" (boolean): True indicates the "Link With Editor" action should not be available for the user (defaults to false).

See Also:
  - Constant Field Values

### PROP_CUSTOMIZE_VIEW_DIALOG_HELP_CONTEXT

static final String PROP_CUSTOMIZE_VIEW_DIALOG_HELP_CONTEXT
"org.eclipse.ui.navigator.customizeViewDialogHelpContext" (string): The help context id to be used for the "Filters and Customization" view dialog, if not specified help will not be available.

Since:
  3.5
See Also:
  - Constant Field Values

### PROP_ENABLE_TOOLTIP_SUPPORT

static final String PROP_ENABLE_TOOLTIP_SUPPORT
"org.eclipse.ui.navigator.enableTooltipSupport" (boolean): True indicates that tooltip support shall be installed for the viewer. (Note: this only enables the general support to display tooltips. The actual tooltip text needs to be contributed by the contributed label providers.) (defaults to false).

Since:
  3.8
See Also:
  - Constant Field Values

## Method Details

### getViewerId

String getViewerId()
Returns the id of the viewer targeted by this extension.

Returns:
  the id of the viewer targeted by this extension.

### getPopupMenuId

String getPopupMenuId()
The default value of the popup menu id is the viewer id. Clients may override this value using a navigatorConfiguration extension.

Returns:
  The id of the context menu of the viewer.

### isVisibleContentExtension

boolean isVisibleContentExtension(String aContentExtensionId)
Returns true if the content extension of the given id is 'visible'. A content extension is 'visible' if it matches a viewerContentBinding for the given viewer id.

Parameters:
  `aContentExtensionId` - The id to query
Returns:
  True if the content extension matches a viewerContentBinding for the viewer id of this descriptor.

### isVisibleActionExtension

boolean isVisibleActionExtension(String anActionExtensionId)
Returns true if the action extension of the given id is 'visible'. An action extension is 'visible' if it matches a viewerActionBinding for the given viewer id.

Parameters:
  `anActionExtensionId` - The id to query
Returns:
  True if the action extension matches a viewerActionBinding for the viewer id of this descriptor.

### isRootExtension

boolean isRootExtension(String aContentExtensionId)
Returns true if the content extension of the given id matches a viewerContentBinding extension that declares isRoot as true.

Parameters:
  `aContentExtensionId` - The id to query
Returns:
  True if the content extension matches a viewerContentBinding which declares 'isRoot' as true for the viewer id of this descriptor.

### hasOverriddenRootExtensions

boolean hasOverriddenRootExtensions()
Returns true if there exists at least one matching viewerContentBinding which declares isRoot as true. This behavior will override the default enablement for the viewer root.

Returns:
  True if there exists a matching viewerContentBinding which declares isRoot as true.

### allowsPlatformContributionsToContextMenu

boolean allowsPlatformContributionsToContextMenu()
Returns true by default. A true value indicates that object and view contributions should be supported by the popup menu of any viewer described by this viewer descriptor. The value may be overridden from the <popupMenu /> child element of the <viewer /> element in the org.eclipse.ui.navigator.viewer extension point.

Returns:
  True if object/view contributions should be allowed or False otherwise.

### getCustomInsertionPoints

MenuInsertionPoint[] getCustomInsertionPoints()
Custom insertion points are declared through a nested 'popupMenu' element in the org.eclipse.ui.navigator.viewer extension point. Each insertion point represents either a `Separator` or `GroupMarker` in the context menu of the viewer.

Returns:
  The set of custom insertion points, if any. A null list indicates the default set (as defined by `NavigatorActionService`) should be used. An empty list indicates there are no declarative insertion points.

### getStringConfigProperty

String getStringConfigProperty(String aPropertyName)

Parameters:
  `aPropertyName` - A property name corresponding to a configuration option from org.eclipse.ui.navigator.viewer
Returns:
  The unmodified string value returned from the extension (null is a possible return value).

### getBooleanConfigProperty

boolean getBooleanConfigProperty(String aPropertyName)

Parameters:
  `aPropertyName` - A property name corresponding to a configuration option from org.eclipse.ui.navigator.viewer
Returns:
  The boolean value returned from the extension (null is a possible return value).

### getHelpContext

String getHelpContext()

Returns:
  the help context associated with this viewer as specified by the helpContext attribute of the <viewer /> element in the org.eclipse.ui.navigator.viewer extension point.
Since:
  3.4